Package tigase.db.ldap

# Class LdapAuthProvider

java.lang.Object
tigase.db.ldap.LdapAuthProvider

All Implemented Interfaces:
  `AuthRepository`, `Repository`

public class LdapAuthProvider extends Object implements AuthRepository

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface tigase.db.AuthRepository

  `AuthRepository.AccountStatus, AuthRepository.DefaultCredentials, AuthRepository.SingleCredential`

  ## Nested classes/interfaces inherited from interface tigase.db.Repository

  `Repository.Meta, Repository.SchemaId`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String[]`
  `non_sasl_mechs`
  `protected static final String[]`
  `sasl_mechs`
  `static final String`
  `USER_DN_PATTERN_KEY`
  Example: `uid=%s,ou=people,dc=xmpp-test,dc=org`

  ### Fields inherited from interface tigase.db.AuthRepository

  `DATA_KEY, DIGEST_ID_KEY, DIGEST_KEY, MACHANISM_KEY, PASSWORD_KEY, PROTOCOL_KEY, PROTOCOL_VAL_NONSASL, PROTOCOL_VAL_SASL, REALM_KEY, RESULT_KEY, SERVER_NAME_KEY, USER_ID_KEY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LdapAuthProvider()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addUser(BareJID user, String password)`
  `AuthRepository.AccountStatus`
  `getAccountStatus(BareJID user)`
  `long`
  `getActiveUsersCountIn(Duration duration)`
  `Credentials`
  `getCredentials(BareJID user, String credentialId)`
  `String`
  `getPassword(BareJID user)`
  `String`
  `getResourceUri()`
  `getResourceUri` method returns database connection string.
  `long`
  `getUsersCount()`
  This method is only used by the server statistics component to report number of registered users.
  `long`
  `getUsersCount(String domain)`
  This method is only used by the server statistics component to report number of registered users for given domain.
  `void`
  `initRepository(String resource_uri, Map<String,String> params)`
  Deprecated.
  `boolean`
  `isUserDisabled(BareJID user)`
  `void`
  `loggedIn(BareJID jid)`
  Do some actions on repository, when user logs in.
  `void`
  `logout(BareJID user)`
  `boolean`
  `otherAuth(Map<String,Object> props)`
  `void`
  `queryAuth(Map<String,Object> authProps)`
  `queryAuth` returns mechanisms available for authentication.
  `void`
  `removeUser(BareJID user)`
  `void`
  `setAccountStatus(BareJID user, AuthRepository.AccountStatus status)`
  `void`
  `setUserDisabled(BareJID user, Boolean value)`
  `void`
  `updatePassword(BareJID user, String password)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface tigase.db.AuthRepository

  `getCredentialIds, getUsernames, isMechanismSupported, removeCredential, setCredentialsCodecs, updateCredential, updateCredential`

- ## Field Details

  - ### USER_DN_PATTERN_KEY

    public static final String USER_DN_PATTERN_KEY
    Example: `uid=%s,ou=people,dc=xmpp-test,dc=org`
    See Also:
      - Constant Field Values

  - ### non_sasl_mechs

    protected static final String[] non_sasl_mechs

  - ### sasl_mechs

    protected static final String[] sasl_mechs

- ## Constructor Details

  - ### LdapAuthProvider

    public LdapAuthProvider()

- ## Method Details

  - ### addUser

    public void addUser(BareJID user, String password) throws UserExistsException, TigaseDBException
    Specified by:
      `addUser` in interface `AuthRepository`
    Throws:
      `UserExistsException`
      `TigaseDBException`

  - ### getCredentials

    public Credentials getCredentials(BareJID user, String credentialId) throws TigaseDBException
    Specified by:
      `getCredentials` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getResourceUri

    public String getResourceUri()
    Description copied from interface: `AuthRepository`
    `getResourceUri` method returns database connection string.
    Specified by:
      `getResourceUri` in interface `AuthRepository`
    Returns:
      a `String` value of database connection string.

  - ### getActiveUsersCountIn

    public long getActiveUsersCountIn(Duration duration)
    Specified by:
      `getActiveUsersCountIn` in interface `AuthRepository`
    Parameters:
      `duration` - Time range within which active users should be counted. Method is only used by statistics.
    Returns:
      number of active users in required range

  - ### getUsersCount

    public long getUsersCount()
    Description copied from interface: `AuthRepository`
    This method is only used by the server statistics component to report number of registered users.
    Specified by:
      `getUsersCount` in interface `AuthRepository`
    Returns:
      a `long` number of registered users in the repository.

  - ### getUsersCount

    public long getUsersCount(String domain)
    Description copied from interface: `AuthRepository`
    This method is only used by the server statistics component to report number of registered users for given domain.
    Specified by:
      `getUsersCount` in interface `AuthRepository`
    Parameters:
      `domain` - for which get the statistics
    Returns:
      a `long` number of registered users in the repository.

  - ### initRepository

    @Deprecated public void initRepository(String resource_uri, Map<String,String> params) throws DBInitException
    Deprecated.
    Description copied from interface: `Repository`
    Method is deprecated and should not be user any more.
    The method is called to initialize the data repository. Depending on the implementation all the initialization parameters can be passed either via `resource_uri` parameter as the database connection string or via `params` map if the required repository parameters are more complex or both.
    Specified by:
      `initRepository` in interface `Repository`
    Parameters:
      `resource_uri` - value in most cases representing the database connection string.
      `params` - is a `Map` with repository properties necessary to initialize and perform all the functions. The initialization parameters are implementation dependent.
    Throws:
      `DBInitException` - if there was an error during repository initialization. Some implementations, though, perform so called lazy initialization so even though there is a problem with the underlying repository it may not be signaled through this method call.

  - ### logout

    public void logout(BareJID user) throws UserNotFoundException, TigaseDBException
    Specified by:
      `logout` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`

  - ### loggedIn

    public void loggedIn(BareJID jid) throws TigaseDBException
    Description copied from interface: `AuthRepository`
    Do some actions on repository, when user logs in. (for example update `last_login_time`)
    Specified by:
      `loggedIn` in interface `AuthRepository`
    Parameters:
      `jid` - JID of logged user.
    Throws:
      `TigaseDBException` - if an error occurs

  - ### otherAuth

    public boolean otherAuth(Map<String,Object> props) throws UserNotFoundException, TigaseDBException, AuthorizationException
    Specified by:
      `otherAuth` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`
      `AuthorizationException`

  - ### queryAuth

    public void queryAuth(Map<String,Object> authProps)
    Description copied from interface: `AuthRepository`
    `queryAuth` returns mechanisms available for authentication.
    Specified by:
      `queryAuth` in interface `AuthRepository`
    Parameters:
      `authProps` - a `Map` value with parameters for authentication.

  - ### removeUser

    public void removeUser(BareJID user) throws UserNotFoundException, TigaseDBException
    Specified by:
      `removeUser` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`

  - ### updatePassword

    public void updatePassword(BareJID user, String password) throws UserNotFoundException, TigaseDBException
    Specified by:
      `updatePassword` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`

  - ### getPassword

    public String getPassword(BareJID user) throws UserNotFoundException, TigaseDBException
    Specified by:
      `getPassword` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`

  - ### isUserDisabled

    public boolean isUserDisabled(BareJID user) throws UserNotFoundException, TigaseDBException
    Specified by:
      `isUserDisabled` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`

  - ### setUserDisabled

    public void setUserDisabled(BareJID user, Boolean value) throws UserNotFoundException, TigaseDBException
    Specified by:
      `setUserDisabled` in interface `AuthRepository`
    Throws:
      `UserNotFoundException`
      `TigaseDBException`

  - ### setAccountStatus

    public void setAccountStatus(BareJID user, AuthRepository.AccountStatus status) throws TigaseDBException
    Specified by:
      `setAccountStatus` in interface `AuthRepository`
    Throws:
      `TigaseDBException`

  - ### getAccountStatus

    public AuthRepository.AccountStatus getAccountStatus(BareJID user) throws TigaseDBException
    Specified by:
      `getAccountStatus` in interface `AuthRepository`
    Throws:
      `TigaseDBException`